/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//		  CMI CSV形式の行 クラス
//変更履歴
//			  2003.11.24	zcj  新規作成
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

import java.util.Vector;
/**
 * CMI CSV形式の行 クラス <BR>
 * @author zhaicj
 * 
 */
public class CMICsvRow {
	/**
	 * CSVの1行分のデータ
	 */
	private String m_CsvOneRow = null;
	
	/**
	 * getNextのときの現在のインデクス
	 */
	private int m_CurIndex;
	
	/**
	 * カンマで分割した要素のリスト
	 */
	private Vector m_Items = null;
   
	/**
	 * コンストラクタ<br>
	 * @param csvData String CSV行データ
	 */
	public CMICsvRow(String csvData) {
		m_CsvOneRow = csvData;
		m_CurIndex = 0;
		m_Items = new Vector();
		parse();   
	}

	/**
	 * コンストラクタ<br>
	 */
	public CMICsvRow() {
		m_CurIndex = 0;
		m_Items = new Vector();
	}
 
	/**
	 * クラスの終了処理 <BR>
	 */
	public void finalize() {
		m_CsvOneRow = null;
		m_CurIndex = 0;
	}
	  
	/**
	 * 次の要素の取得<br>
	 * @return String 次の要素
	 */
	public String getNextItem() {
		String strItem = null;
		if (m_CurIndex < m_Items.size()) {
			strItem = (String)m_Items.elementAt(m_CurIndex++);
		}
		return strItem;
	}
   
	/**
	 * 次の要素の有無<br>
	 * @return boolean 次の要素がある場合true、無い場合false
	 */
	public boolean hasMore() {	
		return (m_CurIndex < m_Items.size());
	}
   
	/**
	 * index番目の要素を取得する<br>
	 * @param index int 取得する要素の位置 
	 * @return String 要素
	 */
	public String getNthItem(int index) {
		if (index < m_Items.size()) {
			return (String)m_Items.elementAt(index);
		} else {
			return null;
		}
	}
	
	/**
	 * 分割後の要素の数を取得する<br>
	 * @return int 要素数
	 */
	public int getCount() {	
		return m_Items.size();
	}
	
	/**
	 * SV形式1行分のデータのセット<br>
	 * @param csvData String CSV行データ
	 */
	public void setCsvData(String csvData) {
		m_CsvOneRow = csvData;
		m_Items.clear();
		m_CurIndex = 0;
		parse();
	}
   
	/**
	 * 要素の分割<br>
	 */
	private void parse() {
		int intHead;
		int intTail;
		String strCamma = ",";
		String strItem = null;
		boolean blnNeedNextItem = false;

	
		intHead = 0;
		if (m_CsvOneRow == null) {
			return;
		}
		while (intHead < m_CsvOneRow.length()) {
			// 空白、タブをスキップ
			intHead = CMIUtil.getIndexNotTab(m_CsvOneRow, intHead);
			if ( m_CsvOneRow.charAt(intHead) == '"' ) {
				// 先頭が引用符のときは、対応する引用符を探す。
				intHead++;
				intTail = m_CsvOneRow.indexOf("\"", intHead);
				if( intTail == -1 ) {
					strItem = m_CsvOneRow.substring(intHead);	
					blnNeedNextItem = false;
					intHead = -1;
				}else{
					strItem = m_CsvOneRow.substring(intHead, intTail);
				}
				// 次のカンマまで進める。
				if (intTail != -1) {
					intTail = m_CsvOneRow.indexOf(strCamma, intTail);
					if (intTail == -1) {
						blnNeedNextItem = false;
						intHead = -1;
					} else {
						intHead = intTail + 1;
						blnNeedNextItem = true;
					}
				}
			} else { 
				// 引用符でないときの処理
				intTail = m_CsvOneRow.indexOf(strCamma, intHead);
				if (intTail == -1) {
					strItem = m_CsvOneRow.substring(intHead);	
					intHead = -1;
					blnNeedNextItem = false;
				} else {
					strItem = m_CsvOneRow.substring(intHead, intTail);
					intHead = intTail + 1;
					blnNeedNextItem = true;
				}
			}
			m_Items.add(strItem);
			if ( intHead == -1) {
				break;
			}
		}
		// 最後のカンマの後が空だったとき
		if (blnNeedNextItem) {	
			m_Items.add(new String(""));
		}  
	}	
}